%{

/*
   cmd.y -- PIKT pikt command-line parser

   $Header: /home/cvs/ucgsb/pikt/src/piktd/cmd.y,v 1.15 2000/02/16 16:13:20 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2000 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include "../lib/common.h"
#include "piktd.h"

%}

%union {
	signed char *sval;
}

%token _MINUS _PLUS _OPT _CHECK _DOUBLECHECK _MAILCMD _LPCMD _ALERT
%token <sval> _ITEM

%%

start:		/* empty */ { ishelp = TRUE; }
		| options
		| items
		| options items
		;

options:	option
		| options option
		;

option:		_MINUS opts
		| _PLUS opts /* no plus opts now, maybe in future */
		;

opts:		_OPT
		| opts _OPT
		;

items:		_MINUS _CHECK alert
		| _MINUS _DOUBLECHECK {
			if (! hostmatch(hostname, master))
				logexit(PIKTLOG, LOG_ERR, __FILE__, __LINE__, FALSE, "attempted doublecheck on non-master system");
			interactive = TRUE;
		} alert
		| alert { interactive = TRUE; }
		| mail alert { interactive = FALSE; }
		| print alert { interactive = FALSE; }
		| mail print alert { interactive = FALSE; }
		| print mail alert { interactive = FALSE; }
		;

mail:		_PLUS _MAILCMD _ITEM { mailcmd = $3; }
		;

print:		_PLUS _LPCMD _ITEM { lpcmd = $3; }
		;

alert:		_PLUS _ALERT _ITEM { altcurr = $3; }
		;

%%
